



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[leetcode]428. Serialize and Deserialize N-ary Tree序列化与反序列化N叉树</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[leetcode]428. Serialize and Deserialize N-ary Tree序列化与反序列化N叉树</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-23 09:13:46 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Serialization is the process of converting a data structure or object into a sequence of bits so that it can be stored in a file or memory buffer, or transmitted across a network connection link to be reconstructed later in the same or another computer environment.</p>
<p>Design an algorithm to serialize and deserialize an N-ary tree. An N-ary tree is a rooted tree in which each node has no more than N children. There is no restriction on how your serialization/deserialization algorithm should work. You just need to ensure that an N-ary tree can be serialized to a string and this string can be deserialized to the original tree structure.</p>
<p>For example, you may serialize the following&nbsp;<code>3-ary</code>&nbsp;tree</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1402496/201811/1402496-20181103042902717-74187366.png" /></p>
<p>as&nbsp;<code>[1 [3[5 6] 2 4]]</code>. You do not necessarily need to follow this format, so please be creative and come up with different approaches yourself.</p>
<p>Note:</p>
<ol><li><code>N</code>&nbsp;is in the range of&nbsp;<code>[1, 1000]</code></li>
<li>Do not use class member/global/static variables to store states. Your serialize and deserialize algorithms should be stateless.</li></ol>
<p>思路</p>
<p>1.&nbsp; preorder recursive traversal</p>
<p>2. add number of children after root val, in order to know when to terminate</p>
<p><strong>1</strong> 3 <strong>3</strong> 2 <strong>5</strong> 0 <strong>6</strong> 0 <strong>2</strong> 0 <strong>4</strong> 0</p>
<p>代码</p>
<div>
<pre class="prettyprint linenums"> /*<br />
 // Definition for a Node.<br />
 class Node {<br />
     public int val;<br />
     public List&lt;Node&gt; children;

     public Node() {}

     public Node(int _val,List&lt;Node&gt; _children) {<br />
         val = _val;<br />
         children = _children;<br />
     }<br />
 };<br />
 */<br />
 class Codec {<br />
  // Encodes a tree to a single string.<br />
     public String serialize(Node root) {<br />
         List&lt;String&gt; list = new LinkedList&lt;&gt;();<br />
         buildString(root, list);<br />
         return String.join(",", list);<br />
     }

     private void buildString(Node root, List&lt;String&gt; list) {<br />
         if (root == null) return;

         list.add(String.valueOf(root.val));<br />
         list.add(String.valueOf(root.children.size()));<br />
         for (Node child : root.children) {<br />
             buildString(child, list);<br />
         }

     }

     // Decodes your encoded data to tree.<br />
     public Node deserialize(String data) {<br />
         if (data.length() == 0) return null;<br />
         String[] strArr = data.split(",");<br />
         Queue&lt;String&gt; queue = new LinkedList&lt;&gt;();<br />
         Collections.addAll(queue, strArr);<br />
         return buildTree(queue);<br />
     }

     private Node buildTree(Queue&lt;String&gt; queue) {<br />
         // match the given constructor form<br />
         Node root = new Node();<br />
         root.val = Integer.parseInt(queue.poll());<br />
         int size = Integer.parseInt(queue.poll());<br />
         root.children = new ArrayList&lt;&gt;(size);<br />
         for (int i = 0; i &lt; size; i++) {<br />
             root.children.add(buildTree(queue));<br />
         }<br />
         return root;<br />
     }<br />
 }

 // Your Codec object will be instantiated and called as such:<br />
 // Codec codec = new Codec();<br />
 // codec.deserialize(codec.serialize(root));</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495pr2vq.html">BZOJ 4569 萌萌哒</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyrvlm8.html">mybatis入门&lowbar;一对多&comma;多对多映射以及整合spring框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv3wwj8.html">mysql 更改默认数据目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4olv38.html">Python操作memcached及redis</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn2x12q.html">vs2015-Azure Mobile Service</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdev0zv9.html">【UVALive - 3211】Now or later （二分&plus;2-SAT）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj51g49.html">Ajax实现的长轮询不阻塞同一时间内页面的其他Ajax请求（同域请求）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okmpde9.html">屌炸天实战 MySQL 系列教程（二） 史上最屌、你不知道的数据库操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn17ey28.html">ios9基础知识（UI）总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd25n79.html">c&num;正则表达式应用实例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1w00oq.html">TortiseGit 添加SSH-Key</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojmpxlq.html">String&period;matches&lpar;&rpar;的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgenpr8.html">linux-centerOs6&period;8安装nginx与配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj1wzk8.html">大数据利器Hive</a>
		</li>
						<li><a href="https://www.batexi.com/a/960p5ej9.html">lamp之apache配置https访问</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pweym48.html">MYSQL INDEX BTREE HASH</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdp3wj9.html">day 30  HTML</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5jzymq.html">03-创建高可用 etcd 集群</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emv4dz9.html">Hive、Spark SQL、Impala比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emdkpx9.html">VS选项中没有C&num;相关设置选项？</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j1wzmg9.html">在Linux中简单实现回收子进程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5eg6mq.html">U3D的结构体堆分配栈分配</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv1jpr8.html">servlet中请求转发（forword）与重定向（sendredirect）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o6zk18.html">linux 3&period;10的list&lowbar;del</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllgo50q.html">Spring3&period;0学习1&period;2（使用annotation）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyym25dq.html">Hibernate学习笔记2&period;2（Hibernate基础Annotation配置）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zydrv19.html">server安装</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1w26w9.html">jq控制select值为某个时选中</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv26kky9.html">03&lowbar;java基础（七）之面向对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyymgj2q.html">openssl数字证书常见格式 协议</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
